'use strict';

const doio = require('../main');
const fs = require('fs');
const tls = require('tls');

var certs = {
    'daojian.w3xm.top' : {
        cert : fs.readFileSync('../tmp/daojian.w3xm.top.pem'),
        key  : fs.readFileSync('../tmp/daojian.w3xm.top.key')
    },

    'www.w3xm.top' : {
        cert : fs.readFileSync('../tmp/www.w3xm.top.pem'),
        key  : fs.readFileSync('../tmp/www.w3xm.top.key')
    }
};

var app = new doio({
    debug: true,
    http2: true,
    https: true,
    server : {
        SNICallback : (servername, cb) => {
            console.log(servername);
            return cb(null, tls.createSecureContext(certs[servername]));
        }
    }
});

var {router} = app;

app.use(async (ctx, next) => {
    console.log('mid');
    await next(ctx);
});

app.use(async (c, next) => {
    if (!c.getFile('image')) {
        c.res.body = 'image not found';
        return ;
    }
    await next();
}, (ctx, name) => {
    if (method !== 'POST' && ctx.group !== 'upload') {
        return false;
    }
    return true;
});

router.get('/', async c => {
    c.res.body = 'ok';
});

router.post('/p', async c => {
    c.res.body = c.body;
});

router.post('/upload', async c => {
    let f = c.getFile('image');
    let fname = c.helper.sha1(`${Date.now()}${Math.random()}`);
    let pathfile = `${process.env.HOME}/tmp/buffer/${fname}${c.helper.extName(f.filename)}`;
    try {
        c.res.body = await c.moveFile(f, pathfile);
    } catch (err) {
        c.res.body = err.message;
    }
}, '@upload');

app.printRoute();
app.daemon(1990, 1);
